#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3200eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 3200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight32004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
          
shot2eight32004xi = { 
                1:'-100x-2126y-2388z',
                2:'-100x-2445y-2061z',
                3:'-1013x-998y-2866z',
                4:'-1024x-2374y-1884z',
                5:'-1031x-440y-2997z',
                6:'-1039x-2066y-2211z',
                7:'-1052x-3011y-255z',
                8:'-1080x-396y-2985z',
                9:'-1086x-963y-2851z',
                10:'-1128x-347y-2974z',
                11:'-1156x-2334y-1858z',
                12:'-1157x-2028y-2187z',
                13:'-1157x-923y-2836z',
                14:'-1174x-295y-2962z',
                15:'-119x-1065y-3120z',
                16:'-1209x-2954y-223z',
                17:'-1216x-239y-2949z',
                18:'-1227x-877y-2822z',
                19:'-1256x-179y-2937z',
                20:'-126x-552y-3149z',
                21:'-1273x-1983y-2164z',
                22:'-1285x-2286y-1832z',
                23:'-1293x-116y-2924z',
                24:'-1295x-827y-2806z',
                25:'-1360x-772y-2791z',
                26:'-1362x-2888y-191z',
                27:'-1387x-1931y-2140z',
                28:'-1413x-2231y-1806z',
                29:'-1424x-712y-2775z',
                30:'-1485x-648y-2759z',
                31:'-1500x-1872y-2116z',
                32:'-1513x-2815y-159z',
                33:'-1538x-2168y-1779z',
                34:'-1542x-579y-2743z',
                35:'-1596x-505y-2726z',
                36:'-1610x-1807y-2092z',
                37:'-163x-575y-3143z',
                38:'-1647x-428y-2709z',
                39:'-1659x-2733y-127z',
                40:'-1660x-2099y-1753z',
                41:'-1717x-1735y-2068z',
                42:'-175x-1055y-3015z',
                43:'-1780x-2022y-1726z',
                44:'-1800x-2643y-95z',
                45:'-1821x-1657y-2043z',
                46:'-1895x-1938y-1699z',
                47:'-1921x-1572y-2019z',
                48:'-1936x-2546y-63z',
                49:'-2006x-1848y-1672z',
                50:'-2016x-1481y-1994z',
                51:'-203x-595y-3137z',
                52:'-2067x-2441y-31z',
                53:'-2108x-1384y-1969z',
                54:'-2113x-1751y-1644z',
                55:'-213x-2142y-2367z',
                56:'-2192x-2330y0z',
                57:'-2194x-1282y-1943z',
                58:'-2215x-1648y-1617z',
                59:'-2276x-1174y-1918z',
                60:'-230x-2457y-2036z',
                61:'-2311x-1538y-1589z',
                62:'-2351x-1061y-1892z',
                63:'-235x-3164y-414z',
                64:'-236x-1074y-3004z',
                65:'-2402x-1423y-1561z',
                66:'-2421x-944y-1866z',
                67:'-246x-613y-3131z',
                68:'-2485x-821y-1840z',
                69:'-2487x-1303y-1533z',
                70:'-2542x-695y-1814z',
                71:'-2566x-1177y-1505z',
                72:'-2593x-565y-1787z',
                73:'-2636x-431y-1761z',
                74:'-2638x-1047y-1477z',
                75:'-2672x-295y-1734z',
                76:'-2703x-912y-1448z',
                77:'-2761x-773y-1420z',
                78:'-2811x-631y-1391z',
                79:'-291x-627y-3124z',
                80:'-300x-1089y-2993z',
                81:'-31x-470y-3165z',
                82:'-329x-2151y-2345z',
                83:'-338x-639y-3117z',
                84:'-361x-2462y-2011z',
                85:'-366x-1100y-2982z',
                86:'-387x-647y-3109z',
                87:'-401x-3151y-382z',
                88:'-434x-1107y-2970z',
                89:'-437x-652y-3102z',
                90:'-446x-2154y-2323z',
                91:'-489x-653y-3094z',
                92:'-493x-2459y-1986z',
                93:'-504x-1110y-2958z',
                94:'-543x-650y-3085z',
                95:'-564x-2150y-2301z',
                96:'-566x-3129y-350z',
                97:'-575x-1108y-2946z',
                98:'-597x-643y-3077z',
                99:'-60x-499y-3160z',
                100:'-626x-2449y-1961z',
                101:'-647x-1102y-2933z',
                102:'-652x-632y-3068z',
                103:'-682x-2139y-2279z',
                104:'-69x-3167y-446z',
                105:'-6x-440y-3169z',
                106:'-707x-618y-3058z',
                107:'-720x-1091y-2920z',
                108:'-730x-3099y-319z',
                109:'-759x-2431y-1936z',
                110:'-763x-599y-3049z',
                111:'-793x-1075y-2907z',
                112:'-801x-2122y-2256z',
                113:'-818x-575y-3039z',
                114:'-867x-1054y-2893z',
                115:'-872x-548y-3029z',
                116:'-892x-2406y-1910z',
                117:'-892x-3059y-287z',
                118:'-91x-527y-3154z',
                119:'-920x-2097y-2234z',
                120:'-926x-516y-3018z',
                121:'-940x-1029y-2880z',
                122:'-979x-480y-3008z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3200eight4xi" usage = "target function for charge3200eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3200eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3200EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3200EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE3200EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3200EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3200EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight32004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3200EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3200EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3200EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight32004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight32004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3200EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE3200EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3200EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>




#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3200eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  